<!DOCTYPE html>
<html lang="es">
<head>
    <meta charset="UTF-8">
    <meta http-equiv="X-UA-Compatible" content="IE=edge">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <title>Capitulo_3</title>
</head>
<body>
    <h1>Capitulo 4</h1>
    <a>Ejercicio 2</a>

    <script>

        class Node {
            constructor(val) {
                this.data = val;
                this.left = null;
                this.right = null;
            }
        }   

        let root = null;

        const matrizOrdenada = (array, inicio, final) => {
            if (inicio > final) {
                return null; 
            }

            let mid = parseInt((inicio + final) / 2),
               node = new Node(array[mid]);

            node.left = matrizOrdenada(array, inicio, mid - 1);
            node.right = matrizOrdenada(array, mid + 1, final);
            return node;
        }

        const ordenar  = (node) => {

            if (node === null) {
                return;
            }
                
            console.log(`${node.data}  `);
            ordenar(node.left);
            ordenar(node.right);
        }

        let array = [1, 2, 3, 4, 5, 6, 7];
        let nodo = array.length;
        root = matrizOrdenada(array, 0, nodo - 1);
        console.log("Arbol de Búsqueda Binaria con altua mínima:");
        ordenar(root)
    
        
    </script>
    
</body>
</html>